{ ।}
{1997 (c) by Igor Dikshew // Uni Tula}

UNIT WinEdit;

INTERFACE

USES CRT, DOS, WIN, WinHarry;

const
      L5000=10;

TYPE

    PointStrArr = ^S ;
    S = Array[1..L5000] of String[78];

    WIND = RECORD
     X1,X2 : Word;             { न      }
     COL   : Word;             { ⢮ ⮫殢 }
     PS    : PointStrArr ;     { ᨢ ப        }
    END;

    DISPL = RECORD
      X,Y : Word;                { न । }
      W : ARRAY [1..7] OF WIND;  { ᨢ  ।}
      WREAL : Word;              { ⢮       }
      LIN : Word;                {  ⢮ ப    }
    END;

CONST
      FrameCol  = Black;         {  ࠬ          }
      GroundCol = LightGray;     {             }
      TitleCol  = Black;         {        }
      TextCol   = Black;         {  ⥪         }
      TLCol     = Green;         {  ⥪饩 ப }
VAR
    q:String[4];
    St : String[78];             {  ப         }
    Ch : Char;                   { 騩 ᨬ         }
    KX,KY : Word;                { न      }
    Realize : Word;              {       }
    TLin : Word;                 {            }
    TOkn : Word;                 { 饥            }
    Ins : Boolean;               {  ⠢          }
    Okn : Displ;                 { ଠ  । }
    Title : String[80];          {  ।     }
    Zap : Boolean;               { ଠ 맮 । }
    i,j,k,l,m,n : Word;

function IntToStr(I: Longint): String;

 (**************************************************************)
 (*                                                            *)
 (*                       HELP OF EDITOR                       *)
 (*                                                            *)
 (*  Title -   ।                                *)
 (*  Okn.Lin - ⢮ ப     1  22             *)
 (*  Okn.WReal - ⢮   ।  1  6         *)
 (*  Okn.x , Okn.y -न 孥  㣫 ।  *)
 (*  Okn.W[i].Col - ⢮ ⮫殢   [ i<=6 ]        *)
 (*  Init   - 楤 樠樨 ।                *)
 (*  Editor - 맮 㭪権 ।                          *)
 (*  Done   - ⨥ ।   ࠢ          *)
 (*                                                            *)
 (**************************************************************)
{
 Title:=' ਬ ';
 Okn.Lin:=10;
 Okn.WReal:=2;
 Okn.x:=40;
 Okn.y:=10;
 Okn.W[1].Col:=25;
 Okn.W[2].Col:=10;
 Init;
 Editor;
 Done;
}

PROCEDURE INIT;
PROCEDURE Done;
PROCEDURE Editor;

IMPLEMENTATION

function IntToStr(I: Longint): String;
{ Convert any integer type to a string }
var
  S: string[11];
begin
  Str(I, S);
  IntToStr := S;
end;

PROCEDURE INIT;
BEGIN
     SaveCurrentScreenOnDisk ('WinEdit.$$$');
     For i := 1 TO Okn.WReal DO
        New( Okn.W[i].PS ) ;
     SetO;
     L:=Okn.WReal+Okn.WReal;
     for i:=1 to Okn.Wreal do
       l:=l+Okn.W[i].Col;
     Window(Okn.x,Okn.y,Okn.x+l,Okn.y+Okn.Lin+1);
     FillWin(' ',GroundCol+16*GroundCol);
     FrameWin(Title,SingleFrame,TitleCol+16*GroundCol,FrameCol+16*GroundCol);
     TextAttr:=FrameCol+16*GroundCol; j:=0;
     if Okn.Wreal>1 then begin
       for i:=1 to Okn.WReal-1 do begin
        j:=j+Okn.W[i].Col+1;
          for k:=1 to Okn.Lin do begin
            GotoXY(j+1,k);
            Write('');
          end;
       Okn.W[i].x1:=Okn.x+j-Okn.W[i].Col;
       Okn.W[i].x2:=Okn.x+j;
       Inc(j);
      end;
     end;
     if Okn.WReal>1 then begin
        j:=j+Okn.W[Okn.WReal].Col+1;
       Okn.W[Okn.WReal].x1:=Okn.x+j-Okn.W[Okn.WReal].Col;
       Okn.W[Okn.WReal].x2:=Okn.x+j;
     end;
     if Okn.WReal=1 then begin
       Okn.W[1].x1:=1;
       Okn.W[1].x2:=Okn.W[Okn.Wreal].Col;
     end;
     TextAttr:=TextCol+16*GroundCol;
     for i:=1 to Okn.WReal do
       for j:=1 to L5000 do
         Okn.W[i].PS^[j]:='';
     St:='';
     kx:=1;
     ky:=1;
     Realize:=1;
     Tlin:=1;
     Tokn:=1;
     Ins:=False;
     SetN;
     GotoXY(1,1);
END;

PROCEDURE Done;
BEGIN
     For i := Okn.WReal DownTO 1 DO
        Dispose(Okn.W[i].PS );
     Window(1,1,80,25);
     LoadScreenFromDisk ('WINEDIT.$$$');
END;

PROCEDURE RePrintAllLine;
BEGIN
     Textattr:=TextCol+16*GroundCol;
     for i:=1 to Okn.WReal do begin
       Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
       for j:=1 to Realize do begin
           GotoXY (1, j);
           Write (Okn.W[i].PS^[j]);
       end;
     end;
     St:=Okn.W[TOkn].PS^[TLin];
     Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
END;

PROCEDURE Editor;
BEGIN
      IF (TOkn = TLin) AND (TOkn = 1) THEN BEGIN
         Window(1,1,79,25);
         TextAttr:=TitleCol+16*GroundCol;
         GotoXY(Okn.x+2,Okn.y+Okn.Lin+1) ;
                           Write('1:1');
         GotoXY(Okn.W[Okn.WReal].x2-4,okn.y);
         Write('[]');
      END;
      Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[1].x2,Okn.y+Okn.Lin);
      RePrintAllLine;
      GotoXY(1,1);
      TextAttr:=TextCol+16*TLCol;
      GotoXY(1,ky);
      ClrEol;
      Write(St);
      SetN;
      GotoXY(kx,ky);
REPEAT
      while KeyPressed do Ch:=ReadKey;
      Ch:=ReadKey;
      SetO;
      Textattr:=TextCol+16*GroundCol;
      GotoXY(1,ky);
      ClrEol;
      GotoXY(1,ky);
      Write(St);
      case Ord(Ch) of
      13 : begin
             if TLin<L5000 then begin
                if KY<Okn.Lin then begin
                if kx=1 then if St='' then kx:=2;
                  if ( kx>1) then BEGIN
                  Inc(KY);
                  Inc(Tlin);
                  end;
                  if Realize<L5000 then
                  Inc(Realize);
                  St:='';
                  KX:=1;
                  TextAttr:=TextCol+16*GroundCol;
                    for i:=1 to Okn.Wreal do begin
                      Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
                      GotoXY(1,KY);
                      InsLine;
                      GotoXY(1,ky);
                        for j:=L5000 downto TLin+1 do
                        Okn.W[i].PS^[j]:=Okn.W[i].PS^[j-1];
                      Okn.W[i].PS^[TLin]:=''
                    end;
                  Window(Okn.W[Tokn].x1,Okn.y+1,Okn.W[Tokn].x2,Okn.y+Okn.Lin);
                  GotoXY(kx,ky);
                  TextAttr:=TextCol+16*TLCol;
                  Write(St);
                end else begin
                  Inc(Realize);
                  St:='';
                  Inc(TLin);
                  kx:=1;
                  for i:=1 to Okn.WReal do begin
                    Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
                    GotoXY(1,1);
                    DelLine;
                    GotoXY(1,KY);
                    TextAttr:=TextCol+16*GroundCol;
                    ClrEol;
                      for j:=L5000 downto TLin+1  do begin
                        Okn.W[i].PS^[j]:=Okn.W[i].PS^[j-1];
                      end;
                    Okn.W[i].PS^[TLin]:='';
                  end;
                  Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
                  GotoXY(1,ky); TextAttr:=TextCol+16*TLCol; Write(St);
                end
              end ;
             end;
     8: begin
         GotoXY(12,KY);
         TextAttr:=TextCol+16*GroundCol;
         ClrEol;
         if KX>1 then begin
         Delete(St,kx-1,1);
         Okn.W[TOkn].PS^[TLin]:=St;
         Dec(kx);
         end;
     end;
     27 : begin
                     Exit;
                     end;
     9 : begin
          if Okn.WReal>1 then begin
            if TOkn<Okn.WReal then TOkn:=Tokn+1 ELSE Tokn:=1;
            kx:=1;
           Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
           GotoXY(kx,ky);
           St:=Okn.W[TOkn].PS^[TLin];
           end;
           end;
     25 : begin
          for i:=1 to Okn.WReal do begin
           Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
           GotoXY(1,ky);
           TextAttr:=TextCol+16*GroundCol;
           DelLine;
           for j:=TLin to L5000-1 do
            Okn.W[i].PS^[j]:=Okn.W[i].PS^[j+1];
            Okn.W[i].PS^[L5000]:='';
            j:=Okn.lin-KY;
            if TLin+j<=Realize then begin
            GotoXY(1,Okn.Lin);
            Textattr:=TextCol+16*GroundCol;
            Write(Okn.W[i].PS^[TLin+j]);
            end;
           end;
           if Realize>1 then begin
           Dec(Realize);
           end;
           if ky>1 then begin
           Dec(ky);
           Dec(TLIn);
           end else if TLIn>1 then Dec(TLin);
           Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
           St:=Okn.W[TOkn].PS^[TLin];
           kx:=1;
      end;
     0 : begin
          Ch:=ReadKey;
          case Ord(Ch) of
     15 : begin
          if Okn.WReal>1 then begin
            if TOkn>1 then TOkn:=TOkn-1 ELSE Tokn:=Okn.WReal;
            kx:=1;
           Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
           GotoXY(kx,ky);
           St:=Okn.W[TOkn].PS^[TLin];
           end;
           end;
     75 : begin
          if kx>1 then
          Dec(KX);
          end;
     77 : begin
          if kx<Length(St)+1 then
          Inc(kx);
     end;
      80 : begin
          if TLin<Realize then begin
          if KY<Okn.Lin+1 then begin
             Inc(KY);
             Inc(TLin);
             St:=Okn.W[TOkn].PS^[TLin];
             TextAttr:=TextCol+16*TLCol;
             GotoXY(1,ky);
             Write(St);
             if kx>Length(St) then kx:=Length(St)+1;
             GotoXY(kx,ky);
           end else begin
           Inc(TLIn);
           for i:=1 to Okn.Wreal do begin
     Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
           GotoXY(1,1);
           TextAttr:=TextCol+16*GroundCol;
           DelLine;
           GotoXY(1,Ky);
           St:=Okn.W[i].PS^[TLin];
           Write(St);
           end;
     Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
     St:=Okn.W[Tokn].PS^[TLin];
     if kx>Length(St) then kx:=Length(St)+1;
     end ;
     end;
     end;
      72 : begin
          if TLin>1 then begin
          if KY>1 then begin
             Dec(KY);
             Dec(TLin);
             St:=Okn.W[TOkn].PS^[TLin];
             TextAttr:=TextCol+16*TLCol;
             GotoXY(1,ky);
             Write(St);
             if kx>Length(St) then kx:=Length(St)+1;
             GotoXY(kx,ky);
           end else begin
           Dec(TLIn);
           for i:=1 to Okn.Wreal do begin
     Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
           GotoXY(1,1);
           TextAttr:=TextCol+16*GroundCol;
           InsLine;
           GotoXY(1,Ky);
           St:=Okn.W[i].PS^[TLin];
           Write(St);
           end;
     Window(Okn.W[TOkn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
     St:=Okn.W[Tokn].PS^[TLin];
     if kx>Length(St) then kx:=Length(St)+1;
     end ;
     end;
     end;
    83 : begin
         if Length(St)>1 then begin
         if kx<=Length(St) then begin
         Delete(St,kx,1);
         TextAttr:=TextCol+16*GroundCol;
         GotoXY(1,ky);
         ClrEol;
         OKn.W[TOkn].PS^[TLin]:=St;
         end
         end
         end;
    82 : begin
         if Ins then Ins:=False else Ins:=True;
         end;
    71 : begin
           kx:=1;
         end;
    79 : begin
         kx:=Length(St)+1;
         end;
    73 : begin
        if ky>1 then begin
         Dec(TLin,KY-1);
         ky:=1;
         St:=Okn.W[TOkn].PS^[TLin];
         if kx>Length(St) then kx:=Length(St)+1;
         end;
         end;
   132 : begin
          KY:=1;
          TLin:=1;
          TextAttr:=TextCol+16*GroundCol;
           for i:=1 to Okn.Wreal do begin
             Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
             for j:=1 to Okn.Lin+1 do begin
               St:=Okn.W[i].PS^[j];
               GotoXY(1,j);
               ClrEol;
               Write(St);
             end;
           end;
             Window(Okn.W[Tokn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
               St:=Okn.W[TOkn].PS^[TLin];
           end;
   118 : begin
          TLin:=Realize;
          IF REALIZE>Okn.Lin then begin
          KY:=Okn.Lin+1;
          TextAttr:=TextCol+16*GroundCol;
           for i:=1 to Okn.Wreal do begin
             Window(Okn.W[i].x1,Okn.y+1,Okn.W[i].x2,Okn.y+Okn.Lin);
             j:=Okn.Lin+1; L:=0;
             while j>0 do begin
               St:=Okn.W[i].PS^[rEALIZE-L];
               GotoXY(1,j);
               ClrEol;
               GotoXY(1,j);
               Write(St);
              Dec(j);
              Inc(l)
             end;
           end;
             Window(Okn.W[Tokn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
           end else
           KY:=TLin;
               St:=Okn.W[TOkn].PS^[TLin];
         end;
    81 : begin
           if ky<Okn.Lin+1 then begin
             Inc(TLin,Okn.Lin-Ky+1);
             KY:=(Okn.Lin+1);
               if TLin>Realize then begin
                 j:=TLin-Realize;
                 TLin:=Realize;
                 Dec(KY,j);
               end;
             St:=Okn.W[TOkn].PS^[TLin];
             if kx>Length(St) then kx:=Length(St)+1;
           end;
         end;
    end;
    end;
          else
           if Ins then begin
            if kx<=Length(St) then begin St[kx]:=Ch; Inc(kx); end
            else if kx<Okn.W[TOkn].x2-Okn.W[TOkn].x1 then begin
            St:=St+Ch;
            Inc(kx);
            end;
           end else begin
              if Length(St)<Okn.W[TOkn].x2-Okn.W[TOkn].x1 then begin
                i:=Length(St);
                i:=i+1;
                St[0]:=Chr(i);
              if kx<=Length(St) then
                for i:=Length(St) downto kx do
                 St[i+1]:=St[i];
                St[kx]:=ch;
                Inc(kx);
             end
           end;
           Okn.W[TOkn].PS^[TLin]:=St;
           if kx>Okn.W[TOkn].x2 then Dec(kx);
          end;
    if Ord(Ch)=0 then begin
      GotoXY(1,ky);
    end;
      Window(1,1,79,25);
      TextAttr:=FrameCol+16*GroundCol;
      GotoXY(Okn.x+2,Okn.y+Okn.Lin+1) ;
      q:=IntToStr(Realize);
                        Write(q+':');
      q:=IntToStr(TLin);
      Write(q+'');
      if TLin=1 then q:=#25;
      if TLin=Realize then q:=#24;
      If TLin<Realize then if TLin>1 then q:=#25+#24;
      if Realize=1 then q:='';
      if TLin=L5000 then q:='X';
      GotoXY(Okn.W[Okn.WReal].x2-4,okn.y);
      Write('['+q+']');
      Window(Okn.W[Tokn].x1,Okn.y+1,Okn.W[TOkn].x2,Okn.y+Okn.Lin);
         TextAttr:=TextCol+16*TLCol;
         GotoXY(1,ky);
         ClrEol;
         GotoXY(1,ky);
         Write(St);
         GotoXY(kx,ky);
 if Ins then SetB else SetN;
until False
END;


END.
